<?
/*
This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been write by Olivier.LeCam@crdp.ac-versailles.fr
Ce script  t crit par Olivier.LeCam@crdp.ac-versailles.fr

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/       

////////////////////////////////////////////////////////////////////////////////
// same as option_link (lib.inc.php) except that it does only check the first 
// character of the option value

function MAIL_SPAMASSASSIN_option_link($dbh,$option,$link,$value) { // returns a link for the options editing menu (admin/options.php)
  $query = "select value,tovalid from options where name='$option'";
  $result = pg_exec($dbh,$query);
  $current_value=pg_result($result,0,"value");
  $tovalid=pg_result($result, 0, "tovalid");
  if ($tovalid == "t") { $note="*"; }
  if ($current_value{0} == $value{0} ) {
    return "<B><FONT COLOR=#00AA00 SIZE=+1>$link$note</FONT></B>&nbsp;&nbsp;";
  }
  else {
    return "<A HREF=options.php?action=change&option=$option&value=$value>$link</A>&nbsp;&nbsp;";
  }
}


////////////////////////////////////////////////////////////////////////////////
// Show the spamassassin options

function MAIL_SPAMASSASSIN_showOptions($db)
{
        include("../../slis.conf.php");
        include("../inc/lang/$LANGUAGE.inc.php");

        if( is_tovalid($db) )
                print "<p><center><i>*$lang_Options_warning</i></center></p>";

        MAIL_SPAMASSASSIN_explodeParams($db, $running, $option, $mailto);

        switch( $option ) {
        case 'D' :      // Direct : mail is sent to the recipicient as usual
                $direct_checked = 'checked';
                break;
        case 'R' :      // Redirected to a different user
                $redirect_checked = 'checked';
                break;
        case 'T' :      // Mail will be trashed
                $trash_checked = 'checked';
                break;
        }

        $http_code .= "$lang_MailSpamAssassin_willbe\n";

        $http_code .= "<form name='mail_spamassassin' method='post' action=$PHP_SELF>\n";
        $http_code .= "<ul>\n";
        $http_code .= "<input type='radio' name='option' value='D' $direct_checked>\n";
        $http_code .= "$lang_MailSpamAssassin_direct<br>\n";

        $http_code .= "<input type='radio' name='option' value='R' $redirect_checked>\n";
        $http_code .= "$lang_MailSpamAssassin_redirect <input type='text' name='mailto' value='$mailto' size='12'>@$HOSTNAME&nbsp;<br>\n";

        $http_code .= "<input type='radio' name='option' value='T' $trash_checked>\n";
        $http_code .= "$lang_MailSpamAssassin_trash<br>\n";

        $http_code .= "</ul>\n";

        // Validate button
        $http_code .= "<center><input type='submit' value='$lang_validate' name='validate'></center>\n";

        // hidden variable
        $http_code .= "<input type='hidden' name='running' value='$running'>\n";

        $http_code .= "</form>\n";

        return $http_code;
}

////////////////////////////////////////////////////////////////////////////////
// set spamassassin options

function MAIL_SPAMASSASSIN_setOptions($db, $running, $option, $mailto)
{
        // check validity
        if( $option != 'D' && $option != 'R' && $option != 'T' )
              return 'option';

        // user must exist if option is set to redirect
        if( $option == 'R' && check_login($db, $mailto) != 'already' )
                return 'user_unknown';

        $value = sprintf("%d:%s:%s", $running, $option, $mailto);
        set_option($db, 'MAIL_SPAMASSASSIN', $value);
        return 'ok';
}

////////////////////////////////////////////////////////////////////////////////
// Explode the 3 parameters of the MAIL_SPAMASSASSIN from the option table

function MAIL_SPAMASSASSIN_explodeParams($db, &$running, &$option, &$mailto)
{
        $query = "SELECT value FROM options WHERE name='MAIL_SPAMASSASSIN'";
        $result = pg_exec($db,$query);
        $value=pg_result($result, 0, 'value');
        
        list($running, $option, $mailto) = explode(':', $value);
}

?>
